#!/usr/bin/perl 


my $daemon = SOAP::Transport::HTTP::Daemon::ForkOnAccept
	 -> new (LocalAddr => 'tag.u-strasbg.fr', LocalPort => 9802, Reuse => 1)
	  -> dispatch_to ('Server');
	
	print "Contact SOAP server at ", $daemon->url, "\n";
	$daemon->handle;
	BEGIN {
		package SOAP::Transport::HTTP::Daemon::ForkOnAccept;

		use strict;
		use vars qw(@ISA);
		use SOAP::Transport::HTTP;

		# Idea and implementation of Michael Douglass

		@ISA = qw(SOAP::Transport::HTTP::Daemon);

		sub handle {
		  my $self = shift->new;

		  CLIENT:
		  while (my $c = $self->accept) {
		    my $pid = fork();

		    # We are going to close the new connection on one of two conditions
		    #  1. The fork failed ($pid is undefined)
		    #  2. We are the parent ($pid != 0)
		    unless( defined $pid && $pid == 0 ) {
		      $c->close;
		      next;
		    }
		    # From this point on, we are the child.

		    $self->close;  # Close the listening socket (always done in children)
		
		    # Handle requests as they come in
		    while (my $r = $c->get_request) {
		      $self->request($r);
		      $self->SOAP::Transport::HTTP::Server::handle;
		      $c->send_response($self->response);
		    }
		    $c->close;
		    return;
		  }
		}
1;
	  package Server;
	  use Cwd;
	  my $dir = getcwd;
	  print "* Files will be browsed in dir:", $dir,"\n";
	  sub my_mpirun {
	  	my ($class, $pa_rams) = @_;
		my @temp = split(/:/,$pa_rams);
		my $file = shift(@temp);
		my $n = shift(@temp);
		my $opt = shift(@temp);
		my $loc = shift(@temp);
		my $file_ext=$file;
		$file =~ s/\.class//;		
		print "$file\n";
 		print "Executing p2pmpirun -n $n $opt $file_ext\n";
		
		my $f_content = join(":",@temp);
		if ($loc eq "local")
		{	open(CLASSFILE,">$dir/$file_ext") || die "impossible de creer $dir/$file : $!\n";
			print CLASSFILE $f_content;
			close(CLASSFILE);
		}
		unlink("$dir/$file.log");
		open(RESULT_F, ">>$dir/$file.log");
		print("ouput directed to: $dir/$file.log\n");
		open(DF, "p2pmpirun -n $n $opt $file |");
		while(<DF>){
			my $vieux_df=select(RESULT_F);
			$| = 1;
			select($vieux_df);
			print RESULT_F "$_";
		}
		close (DF);
		print RESULT_F "\n---- APPLICATION TERMINEE ----\n";
		close (RESULT_F);
		return;	
  	  }
	  sub my_ls {
	  	my ($class, $pa_rams) = @_;
	  	my $chaine = "$dir";
		$chaine.="/*$pa_rams";
		my @bin_files;
		my $i=0;
		while ($bin_files[$i] = glob("$chaine"))
		{	$bin_files[$i] =~ s#.*/##;
			$i++;
		}
		my $retour = join(":",@bin_files);
		return $retour;
	  }
	  sub resultat {
	  	my ($class, $pa_rams) = @_;
		my $retour = "";
		$pa_rams =~ s/\.class//;
		open(DF, "/bin/cat $dir/$pa_rams.log |");
		while(<DF>){
			$retour .= "$_";
		}
		close(DF);
	  	return $retour;	
	 }
	 sub my_cat  {
	  	my ($class, $pa_rams) = @_;
		my $retour = "";
		open(DF, "/bin/cat $dir/$pa_rams |");
		while(<DF>){
			$retour .= "$_";
		}
		close(DF);
	  	return $retour;	
	}
	sub my_pwd
 	{	return "$dir/";
	}
	sub my_upload {
	  	my ($class, $pa_rams) = @_;
		my @temp = split(/:/,$pa_rams);
		my $file = shift(@temp);
		print "enregistrement de $dir/$file\n";
		my $f_content = join(":",@temp);
		open(CLASSFILE,">$dir/$file") || die "impossible de creer $dir/$file : $!\n";
		print CLASSFILE $f_content;
		close(CLASSFILE);
		return;
	}
}	
